include libmacro.inc

beglib

item	'TWORD','*'
	lax 02

item	'TSHORT','*'
	lax 04

item	'TLONG','*'
	lax 08

item	'TSINGLE','*'
	lax 04

item	'TDOUBLE','*'
	lax 08

item	'TEXTENDED','*'
	lax 10

item	'fldword','*'
	mov	bx, ax
	fild	word ptr [bx]
	pop	ax


item	'fldshort','*'
	mov	bx, ax
	fild	dword ptr [bx]
	pop	ax

item	'fldlong','*'
	mov	bx, ax
	fild	qword ptr [bx]
	pop	ax

item	'fldsingle','*'
	mov	bx, ax
	fld	dword ptr [bx]
	pop	ax

item	'flddouble','*'
	mov	bx, ax
	fld	qword ptr [bx]
	pop	ax

item	'fldextended','*'
	mov	bx, ax
	fld	tbyte ptr [bx]
	pop	ax

item	'fstword','*'
	mov	bx, ax
	fistp 	word ptr [bx]
	pop	ax

item	'fstshort','*'
	mov	bx, ax
	fistp 	dword ptr [bx]
	pop	ax

item	'fstlong','*'
	mov	bx, ax
	fistp 	qword ptr [bx]
	pop	ax

item	'fstsingle','*'
	mov	bx, ax
	fstp 	dword ptr [bx]
	pop	ax

item	'fstdouble','*'
	mov	bx, ax
	fstp 	qword ptr [bx]
	pop	ax

item	'fstextended','*'
	mov	bx, ax
	fstp 	tbyte ptr [bx]
	pop	ax



;		{*** CONSTANTS ***}

item	'fldz','*'
	fldz

item	'fld1','*'
	fld1

item	'fldpi','*'
	fldpi

item	'fldl2t','*'
	fldl2t

item	'fldl2e','*'
	fldl2e

item	'fldlg2','*'
	fldlg2

item	'fldln2','*'
	fldln2

;		{*** COMPARE ***}

item	'fcom','*'
	fcom 

item	'fcompp','*'
	fcompp

item	'ftst','*'
	ftst 

;		{*** ARITHMETIC ***}

item	'fadd','*'
	fadd

item	'fsub','*'
	fsub

item	'fmul','*'
	fmul

item	'fdiv','*'
	fdiv

item	'fsqrt','*'
	fsqrt

item	'fscale','*'
	fscale

item	'fxtract','*'
	fxtract

item	'fprem','*'
	fprem


item	'frndint','*'
	frndint

item	'fabs','*'
	fabs

item	'fchs','*'
	fchs
	

;		{*** TRNSCENDENTAL ***}
item	'fcos','*'
	fcos

item	'fptan','*'
	fptan

item	'fpatan','*'
	fpatan

item	'fsin','*'
	fsin

item	'fsincos','*'
	fsincos

item	'f2xm1','*'
	f2xm1

item	'fyl2x','*'
	fyl2x

item	'fyl2xp1','*'
	fyl2xp1


;		{*** CONTROL ***}

item	'finit','*'
	finit	

item	'fwait','*'
	fwait


;		{*** END OF FPC ***}
endlib